set OPSChannel [open model.tcl w]
set mNodeInfo  [open nodeInfo.dat w]
set eleFile    [open elementInfo.dat w]
set fixFile    [open nodeFixitiesInfo.dat w]
set eqDOFFile  [open nodeEqualDOFInfo.dat w]
set firstCall  [open firstCall.dat w]
set postShake  [open postShake.dat w]
puts $OPSChannel {}
puts $OPSChannel {####################################################################}
puts $OPSChannel {#  This file was made using the UWquad2D problem type in GiD.      #}
puts $OPSChannel {#  Created by:  Chris McGann and Pedro Arduino, 2010               #}
puts $OPSChannel {#              -University of Washington-                          #}
puts $OPSChannel {####################################################################}
puts $OPSChannel {}
puts $OPSChannel {wipe}
puts $OPSChannel {}
puts $OPSChannel {#-----------------------------------------------------------------------------------------}
puts $OPSChannel {#  1. CREATE SOIL NODES AND FIXITIES}
puts $OPSChannel {#-----------------------------------------------------------------------------------------}
*#
*# determine the designated number of degrees of freedom and specified element type
*set Cond Nodal_DOF_on_surfaces *nodes
*add Cond Nodal_DOF_on_lines *nodes
*add Cond Nodal_DOF_on_nodes *nodes
*loop nodes *OnlyInCond
*if(cond(1,int)==2)
puts $OPSChannel {model BasicBuilder -ndm 2 -ndf 2}
*set var mDOF(int)=2
*if(strcmp(cond(2),"quad")==0)
*set var mElemType(int)=1
*elseif(strcmp(cond(2),"SSPquad")==0)
*set var mElemType(int)=2
*endif
*break
*elseif(cond(1,int)==3)
puts $OPSChannel {model BasicBuilder -ndm 2 -ndf 3}
*set var mDOF(int)=3
*if(strcmp(cond(2),"quadUP")==0)
*set var mElemType(int)=3
*elseif(strcmp(cond(2),"SSPquadUP")==0)
*set var mElemType(int)=4
*endif
*break
*endif
*end nodes
puts $OPSChannel {}
puts $OPSChannel {# define soil nodes}
*loop nodes *OnlyInCond
*format "%8i %10.3f %10.3f"
puts $OPSChannel {node *NodesNum *NodesCoord}
*end nodes
puts $OPSChannel {puts "Finished creating all -ndf 2 nodes..."}
puts $OPSChannel {}
# create list of all nodes and locations 
*loop nodes *OnlyInCond
*format "%8i %10.3f %10.3f"
puts $mNodeInfo "*NodesNum *NodesCoord"
*end nodes
close $mNodeInfo
puts $OPSChannel {}
puts $OPSChannel {# define fixities for soil nodes}
*if(mDOF(int)==2)
*set Cond 2_DOF_Point_Constraints_on_surfaces *nodes
*add Cond 2_DOF_Point_Constraints_on_lines *nodes
*add Cond 2_DOF_Point_Constraints_on_nodes *nodes
*loop nodes *OnlyInCond
*format "%5i %2i %2i"
puts $OPSChannel {fix *NodesNum *cond(1) *cond(2)}
puts $fixFile {*NodesNum *cond(1) *cond(2)}
*end nodes
puts $OPSChannel {puts "Finished creating all -ndf 2 boundary conditions..."}
*elseif(mDOF(int)==3)
*set Cond 3_DOF_Point_Constraints_on_surfaces *nodes
*add Cond 3_DOF_Point_Constraints_on_lines *nodes
*add Cond 3_DOF_Point_Constraints_on_nodes *nodes
*loop nodes *OnlyInCond
*format "%5i %2i %2i %2i"
puts $OPSChannel {fix *NodesNum *cond(1) *cond(2) *cond(3)}
puts $fixFile {*NodesNum *cond(1) *cond(2) *cond(3)}
*end nodes
puts $OPSChannel {puts "Finished creating all -ndf 3 boundary conditions..."}
*endif
puts $OPSChannel {}
puts $OPSChannel {# define equal degrees of freedom for free-field columns}
*loop nodes 
*set Cond EqualDOF_01_on_lines *nodes
*add Cond EqualDOF_01_on_nodes *nodes
*loop nodes *OnlyInCond
*if(strcmp(cond(1),"master")==0)
*set var mstrY(real) = NodesCoord(2,real)
*set var mstrNode(int) = NodesNum(int)
*loop nodes *OnlyInCond
*set var slvY(real) = NodesCoord(2,real)
*set var diffY(real) = operation(mstrY-slvY)
*if((strcmp(cond(1),"slave")==0)&&(fabs(diffY)<0.0000001))
puts $OPSChannel {equalDOF *mstrNode *NodesNum  1 2}
puts $eqDOFFile {*mstrNode *NodesNum  1 2}
*endif
*end nodes
*endif
*end nodes
*set var eqDOF2(int) = 0
*set Cond EqualDOF_02_on_lines *nodes
*add Cond EqualDOF_02_on_nodes *nodes
*loop nodes *OnlyInCond
*if(strcmp(cond(1),"master")==0)
*set var eqDOF2(int) = 1
*endif
*end nodes
*if(eqDOF2(int)==1)
puts $OPSChannel {}
*loop nodes 
*set Cond EqualDOF_02_on_lines *nodes
*add Cond EqualDOF_02_on_nodes *nodes
*loop nodes *OnlyInCond
*if(strcmp(cond(1),"master")==0)
*set var mstrY(real) = NodesCoord(2,real)
*set var mstrNode(int) = NodesNum(int)
*loop nodes *OnlyInCond
*set var slvY(real) = NodesCoord(2,real)
*set var diffY(real) = operation(mstrY-slvY)
*if((strcmp(cond(1),"slave")==0)&&(fabs(diffY)<0.0000001))
puts $OPSChannel {equalDOF *mstrNode *NodesNum  1 2}
puts $eqDOFFile {*mstrNode *NodesNum  1 2}
*endif
*end nodes
*endif
*end nodes
puts $OPSChannel {puts "Finished creating equalDOF constraints for soil columns..."}
puts $OPSChannel {}
*# base equalDOF
*set Cond Dashpot_properties_and_slave_node *nodes
*loop nodes *OnlyInCond
*if(cond(1,int)==1)
*set var dNode(int) = NodesNum(int)
*endif
*end nodes
*set Cond EqualDOF_forBase_on_lines *nodes
*add Cond EqualDOF_forBase_on_nodes *nodes
*loop nodes *OnlyInCond
*if(cond(1,int)==1)
*if(NodesNum(int)==dNode)
*# do nothing
*elseif(NodesNum(int)!=dNode)
puts $OPSChannel {equalDOF *dNode *NodesNum  1}
puts $eqDOFFile {*dNode *NodesNum  1}
*endif
*endif
*end nodes
puts $OPSChannel {puts "Finished creating equalDOF for base..."}
puts $OPSChannel {}
puts $OPSChannel {#-----------------------------------------------------------------------------------------}
puts $OPSChannel {#  2. CREATE SOIL MATERIALS}
puts $OPSChannel {#-----------------------------------------------------------------------------------------}
*set var matShift=0
*#
*# ... define preliminary parameters
*set var g(real)=Operation(9.81)
*set var matCount(int) = 0
puts $OPSChannel {}
set matPLid {}
set matRho  {}
set matC    {}
set matPhi  {}
*loop materials
*if(strcmp(MatProp(1),"ElasticIsotropic")==0)
*set var matID = operation(matnum+matShift)
puts $OPSChannel {}
puts $OPSChannel {# *matProp(0)}
puts $OPSChannel {nDMaterial ElasticIsotropic *matID *MatProp(3) *MatProp(4) *MatProp(2)}
lappend matPLid *MatProp(13)
lappend matRho *MatProp(2)
lappend matC 0.0
lappend matPhi 0.0
set thick*matnum() *MatProp(10)
*if((mElemType(int)==1)||(mElemType(int)==2))
*set var xWgt(real) = operation(g*MatProp(2,real)*MatProp(8,real))
*set Var yWgt(real) = operation(-g*MatProp(2,real)*MatProp(9,real))
*format "%1i %8.2f"
set xWgt*matnum() *xWgt
set yWgt*matnum() *yWgt
*elseif((mElemType(int)==3)||(mElemType(int)==4))
*set var xWgt(real) = operation(g*MatProp(8,real))
*set Var yWgt(real) = operation(-g*MatProp(9,real))
*format "%1i %8.2f"
puts $OPSChannel {set xWgt*matnum() *xWgt}
puts $OPSChannel {set yWgt*matnum() *yWgt}
puts $OPSChannel {set uBulk*matnum() *MatProp(5)}
puts $OPSChannel {set hPerm*matnum() *MatProp(6)}
puts $OPSChannel {set vPerm*matnum() *MatProp(7)}
*if(mElemType(int)==4)
puts $OPSChannel {set mVoid*matnum() *MatProp(11)}
puts $OPSChannel {set mAlpha*matnum() *MatProp(12)}
*endif
*endif
*endif
*#
*if(strcmp(MatProp(1),"PressureDependMultiYield")==0)
*set var matID = operation(matnum+matShift)
puts $OPSChannel {}
puts $OPSChannel {# *matProp(0)}
puts $OPSChannel {nDMaterial PressureDependMultiYield *matID 2 *MatProp(2) *MatProp(3) *MatProp(4) *MatProp(5) *MatProp(6) *\
*MatProp(7) *MatProp(8) *MatProp(9) *MatProp(10) *MatProp(11) *MatProp(12) *\     
*MatProp(13) *MatProp(14) *MatProp(15) *MatProp(16) *MatProp(17) *\ 
*MatProp(18) *MatProp(19) *MatProp(20) *MatProp(21)}
lappend matPLid *MatProp(29)
lappend matRho *MatProp(2)
lappend matC 0.0
lappend matPhi *MatProp(5)
puts $OPSChannel {set thick*matnum() *MatProp(27)}
*if((mElemType(int)==1)||(mElemType(int)==2))
*set var xWgt(real) = operation(g*MatProp(2,real)*MatProp(25,real))
*set Var yWgt(real) = operation(-g*MatProp(2,real)*MatProp(26,real))
*format "%1i %8.2f"
puts $OPSChannel {set xWgt*matnum() *xWgt}
puts $OPSChannel {set yWgt*matnum() *yWgt}
*elseif((mElemType(int)==3)||(mElemType(int)==4))
*set var xWgt(real) = operation(g*MatProp(25,real))
*set Var yWgt(real) = operation(-g*MatProp(26,real))
*format "%1i %8.2f"
puts $OPSChannel {set xWgt*matnum() *xWgt}
puts $OPSChannel {set yWgt*matnum() *yWgt}
puts $OPSChannel {set uBulk*matnum() *MatProp(22)}
puts $OPSChannel {set hPerm*matnum() *MatProp(23)}
puts $OPSChannel {set vPerm*matnum() *MatProp(24)}
*if(mElemType(int)==4)
puts $OPSChannel {set mVoid*matnum() *MatProp(17)}
puts $OPSChannel {set mAlpha*matnum() *MatProp(28)}
*endif
*endif
*endif
*#
*if(strcmp(MatProp(1),"PressureDependMultiYield02")==0)
*set var matID = operation(matnum+matShift)
puts $OPSChannel {}
puts $OPSChannel {# *matProp(0)}
puts $OPSChannel {nDMaterial PressureDependMultiYield02 *matID 2 *MatProp(2) *MatProp(3) *MatProp(4) *MatProp(5) *MatProp(6) *\  
*MatProp(7) *MatProp(8) *MatProp(9) *MatProp(10) *MatProp(11) *MatProp(12) *\
*MatProp(13) *MatProp(14) *MatProp(15) *MatProp(16) *MatProp(17) *\ 
*MatProp(18) *MatProp(19) *MatProp(20) *MatProp(21) *MatProp(22) *MatProp(23)}
lappend matPLid *MatProp(31)
lappend matRho *MatProp(2)
lappend matC 0.0
lappend matPhi *MatProp(5)
puts $OPSChannel {set thick*matnum() *MatProp(29)}
*if((mElemType(int)==1)||(mElemType(int)==2))
*set var xWgt(real) = operation(g*MatProp(2,real)*MatProp(27,real))
*set Var yWgt(real) = operation(-g*MatProp(2,real)*MatProp(28,real))
*format "%1i %8.2f"
puts $OPSChannel {set xWgt*matnum() *xWgt}
puts $OPSChannel {set yWgt*matnum() *yWgt}
*elseif((mElemType(int)==3)||(mElemType(int)==4))
*set var xWgt(real) = operation(g*MatProp(27,real))
*set Var yWgt(real) = operation(-g*MatProp(28,real))
*format "%1i %8.2f"
puts $OPSChannel {set xWgt*matnum() *xWgt}
puts $OPSChannel {set yWgt*matnum() *yWgt}
puts $OPSChannel {set uBulk*matnum() *MatProp(24)}
puts $OPSChannel {set hPerm*matnum() *MatProp(25)}
puts $OPSChannel {set vPerm*matnum() *MatProp(26)}
*if(mElemType(int)==4)
puts $OPSChannel {set mVoid*matnum() *MatProp(19)}
puts $OPSChannel {set mAlpha*matnum() *MatProp(30)}
*endif
*endif
*endif
*#
*if(strcmp(MatProp(1),"PressureIndependMultiYield")==0)
*set var matID = operation(matnum+matShift)
puts $OPSChannel {}
puts $OPSChannel {# *matProp(0)}
puts $OPSChannel {nDMaterial PressureIndependMultiYield *matID 2 *MatProp(2) *MatProp(3) *MatProp(4) *MatProp(5) *MatProp(6) *\
*MatProp(7) *MatProp(8) *MatProp(9) *MatProp(10)}
lappend matPLid *MatProp(19)
lappend matRho *MatProp(2)
lappend matC *MatProp(5)
lappend matPhi *MatProp(7)
puts $OPSChannel {set thick*matnum() *MatProp(16)}
*if((mElemType(int)==1)||(mElemType(int)==2))
*set var xWgt(real) = operation(g*MatProp(2,real)*MatProp(14,real))
*set Var yWgt(real) = operation(-g*MatProp(2,real)*MatProp(15,real))
*format "%1i %8.2f"
puts $OPSChannel {set xWgt*matnum() *xWgt}
puts $OPSChannel {set yWgt*matnum() *yWgt}
*elseif((mElemType(int)==3)||(mElemType(int)==4))
*set var xWgt(real) = operation(g*MatProp(14,real))
*set Var yWgt(real) = operation(-g*MatProp(15,real))
*format "%1i %8.2f"
puts $OPSChannel {set xWgt*matnum() *xWgt}
puts $OPSChannel {set yWgt*matnum() *yWgt}
puts $OPSChannel {set uBulk*matnum() *MatProp(11)}
puts $OPSChannel {set hPerm*matnum() *MatProp(12)}
puts $OPSChannel {set vPerm*matnum() *MatProp(13)}
*if(mElemType(int)==4)
puts $OPSChannel {set mVoid*matnum() *MatProp(17)}
puts $OPSChannel {set mAlpha*matnum() *MatProp(18)}
*endif
*endif
*endif
*#
*if(strcmp(MatProp(1),"J2Plasticity")==0)
*set var matShift=0
*set var matID = operation(matnum+matShift)
puts $OPSChannel {}
puts $OPSChannel {# *matProp(0)}
puts $OPSChannel {nDMaterial J2Plasticity *matID *MatProp(3) *MatProp(4) *MatProp(5) *MatProp(6) *MatProp(7) *MatProp(8) 0.0 *MatProp(2)}
lappend matPLid *MatProp(17)
lappend matRho *MatProp(2)
lappend matC 0.0
lappend matPhi 0.0
puts $OPSChannel {set thick*matnum() *MatProp(14)}
*if((mElemType(int)==1)||(mElemType(int)==2))
*set var xWgt(real) = operation(g*MatProp(2,real)*MatProp(12,real))
*set Var yWgt(real) = operation(-g*MatProp(2,real)*MatProp(13,real))
*format "%1i %8.2f"
puts $OPSChannel {set xWgt*matnum() *xWgt}
puts $OPSChannel {set yWgt*matnum() *yWgt}
*elseif((mElemType(int)==3)||(mElemType(int)==4))
*set var xWgt(real) = operation(g*MatProp(12,real))
*set Var yWgt(real) = operation(-g*MatProp(13,real))
*format "%1i %8.2f"
puts $OPSChannel {set xWgt*matnum() *xWgt}
puts $OPSChannel {set yWgt*matnum() *yWgt}
puts $OPSChannel {set uBulk*matnum() *MatProp(9)}
puts $OPSChannel {set hPerm*matnum() *MatProp(10)}
puts $OPSChannel {set vPerm*matnum() *MatProp(11)}
*if(mElemType(int)==4)
puts $OPSChannel {set mVoid*matnum() *MatProp(15)}
puts $OPSChannel {set mAlpha*matnum() *MatProp(16)}
*endif
*endif
*endif
*#
*if(strcmp(MatProp(1),"PM4Sand")==0)
*set var matID = operation(matnum+matShift)
puts $OPSChannel {}
puts $OPSChannel {# *matProp(0)}
puts $OPSChannel {nDMaterial PM4Sand *matID *MatProp(3) *MatProp(4) *MatProp(5) *MatProp(2) *MatProp(6)}
lappend matPLid *MatProp(12)
lappend matRho *MatProp(2)
lappend matC 0.0
lappend matPhi 0.0
puts $OPSChannel {set thick*matnum() *MatProp(12)}
*if((mElemType(int)==1)||(mElemType(int)==2))
*set var xWgt(real) = operation(g*MatProp(2,real)*MatProp(9,real))
*set Var yWgt(real) = operation(-g*MatProp(2,real)*MatProp(10,real))
*format "%1i %8.2f"
puts $OPSChannel {set xWgt*matnum() *xWgt}
puts $OPSChannel {set yWgt*matnum() *yWgt}
*elseif((mElemType(int)==3)||(mElemType(int)==4))
*set var xWgt(real) = operation(g*MatProp(10,real))
*set Var yWgt(real) = operation(-g*MatProp(11,real))
*format "%1i %8.2f"
puts $OPSChannel {set xWgt*matnum() *xWgt}
puts $OPSChannel {set yWgt*matnum() *yWgt}
puts $OPSChannel {set uBulk*matnum() *MatProp(7)}
puts $OPSChannel {set hPerm*matnum() *MatProp(8)}
puts $OPSChannel {set vPerm*matnum() *MatProp(9)}
*if(mElemType(int)==4)
puts $OPSChannel {set mVoid*matnum() *MatProp(13)}
puts $OPSChannel {set mAlpha*matnum() *MatProp(14)}
*endif
*endif
*endif
*#
*if(strcmp(MatProp(1),"PM4Silt")==0)
*set var matID = operation(matnum+matShift)
puts $OPSChannel {}
puts $OPSChannel {# *matProp(0)}
puts $OPSChannel {nDMaterial PM4Silt *matID *MatProp(3) *MatProp(4) *MatProp(5) *MatProp(6) *MatProp(2) *MatProp(7) *MatProp(8)}
lappend matPLid *MatProp(15)
lappend matRho *MatProp(2)
lappend matC 0.0
lappend matPhi 0.0
puts $OPSChannel {set thick*matnum() *MatProp(14)}
*if((mElemType(int)==1)||(mElemType(int)==2))
*set var xWgt(real) = operation(g*MatProp(2,real)*MatProp(12,real))
*set Var yWgt(real) = operation(-g*MatProp(2,real)*MatProp(13,real))
*format "%1i %8.2f"
puts $OPSChannel {set xWgt*matnum() *xWgt}
puts $OPSChannel {set yWgt*matnum() *yWgt}
*elseif((mElemType(int)==3)||(mElemType(int)==4))
*set var xWgt(real) = operation(g*MatProp(12,real))
*set Var yWgt(real) = operation(-g*MatProp(13,real))
*format "%1i %8.2f"
puts $OPSChannel {set xWgt*matnum() *xWgt}
puts $OPSChannel {set yWgt*matnum() *yWgt}
puts $OPSChannel {set uBulk*matnum() *MatProp(9)}
puts $OPSChannel {set hPerm*matnum() *MatProp(10)}
puts $OPSChannel {set vPerm*matnum() *MatProp(11)}
*if(mElemType(int)==4)
puts $OPSChannel {set mVoid*matnum() *MatProp(15)}
puts $OPSChannel {set mAlpha*matnum() *MatProp(16)}
*endif
*endif
*endif
*end materials
puts $OPSChannel {puts "Finished creating all soil materials..."}
*#
*if(matShift==1000)
puts $OPSChannel {}
puts $OPSChannel {# create wrapper materials for initial state analysis}
*loop materials
*set var matID = operation(matnum+matShift)
puts $OPSChannel {nDMaterial InitialStateAnalysisWrapper *matnum() *matID 2}
*end materials
*endif
puts $OPSChannel {}
puts $OPSChannel {#-----------------------------------------------------------------------------------------}
puts $OPSChannel {#  3. CREATE SOIL ELEMENTS}
puts $OPSChannel {#-----------------------------------------------------------------------------------------}
puts $OPSChannel {}
*if(mElemType(int)==1)
*loop elems
puts $OPSChannel {element quad *ElemsNum *ElemsConec(4,int) *ElemsConec(1,int) *ElemsConec(2,int) *ElemsConec(3,int) *\
$thick*ElemsMat PlaneStrain *ElemsMat 0.0 0.0 $xWgt*ElemsMat $yWgt*ElemsMat}
*end elems
*#
*elseif(mElemType(int)==2)
*loop elems
puts $OPSChannel {element SSPquad *ElemsNum *ElemsConec(4,int) *ElemsConec(1,int) *ElemsConec(2,int) *ElemsConec(3,int) *\
*ElemsMat PlaneStrain $thick*ElemsMat $xWgt*ElemsMat $yWgt*ElemsMat}
*end elems
*#
*elseif(mElemType(int)==3)
puts $OPSChannel {# permeabilities are initial set at 1.0 m/s for gravity analysis, values are updated after gravity}
*loop elems
puts $OPSChannel {element quadUP *ElemsNum *ElemsConec(4,int) *ElemsConec(1,int) *ElemsConec(2,int) *ElemsConec(3,int) *\
$thick*ElemsMat *ElemsMat $uBulk*ElemsMat 1.0 1.0 1.0 $xWgt*ElemsMat $yWgt*ElemsMat}
*end elems
*#
*elseif(mElemType(int)==4)
puts $OPSChannel {# permeabilities are initially set at 1.0 m/s for gravity analysis, values are updated after gravity}
*loop elems
puts $OPSChannel {element SSPquadUP *ElemsNum *ElemsConec(4,int) *ElemsConec(1,int) *ElemsConec(2,int) *ElemsConec(3,int) *\
*ElemsMat $thick*ElemsMat $uBulk*ElemsMat 1.0 1.0 1.0 $mVoid*ElemsMat $mAlpha*ElemsMat $xWgt*ElemsMat $yWgt*ElemsMat}
*end elems
*endif
puts $OPSChannel {puts "Finished creating all soil elements..."}
puts $OPSChannel {}
# create list of element connectivities for post-processing
*loop elems
*format "%8i %8i %8i %8i %8i %8i"
puts $eleFile "*ElemsNum *ElemsConec(4) *ElemsConec(1) *ElemsConec(2) *ElemsConec(3) *ElemsMat"
*end elems
close $eleFile
puts $OPSChannel {}
puts $OPSChannel {#-----------------------------------------------------------------------------------------}
puts $OPSChannel {#  4. LYSMER DASHPOT}
puts $OPSChannel {#-----------------------------------------------------------------------------------------}
*#
*set var iNode = operation(npoin+100)
*set var jNode = operation(iNode+1)
*set Cond Dashpot_properties_and_slave_node *nodes
*loop nodes *OnlyInCond
*if(cond(1,int)==1)
*set var dNode(int) = NodesNum(int)
*set var xCoord(real) = NodesCoord(1,real)
*set var yCoord(real) = NodesCoord(2,real)
*set var C(real) = operation(cond(2,real)*cond(3,real))
*set var mRho(real) = cond(3,real)
*set var baseArea(real) = cond(4,real)
*endif
puts $OPSChannel {}
*if((mElemType(int)==3)||(mElemType(int)==4))
puts $OPSChannel {model BasicBuilder -ndm 2 -ndf 2}
puts $OPSChannel {}
*endif
*#
puts $OPSChannel {# define dashpot nodes}
*format "%8i %10.3f %10.3f%"
puts $OPSChannel {node *iNode *xCoord *yCoord}
*format "%8i %10.3f %10.3f%"
puts $OPSChannel {node *jNode *xCoord *yCoord}
puts $OPSChannel {}
puts $OPSChannel {# define fixities for dashpot nodes}
puts $OPSChannel {fix *iNode  1 1}
puts $OPSChannel {fix *jNode  0 1}
puts $OPSChannel {}
puts $OPSChannel {# define equal DOF for dashpot and base soil node}
puts $OPSChannel {equalDOF *dNode *jNode  1}
puts $OPSChannel {puts "Finished creating dashpot nodes and boundary conditions..."}
puts $OPSChannel {}
puts $OPSChannel {# define dashpot material}
*set var dMat = operation(nmats+1)
*format "%10.2f"
puts $OPSChannel {set baseArea *baseArea}
*format "%10.2f"
puts $OPSChannel {set dashpotCoeff *C}
puts $OPSChannel {uniaxialMaterial Viscous *dMat [expr $dashpotCoeff**$baseArea] 1}
puts $OPSChannel {}
puts $OPSChannel {# define dashpot element}
*set var dElem = operation(nelem+1)
puts $OPSChannel {element zeroLength *dElem *iNode *jNode -mat *dMat -dir 1}
puts $OPSChannel {puts "Finished creating dashpot material and element..."}
puts $OPSChannel {}
*end nodes
puts $OPSChannel {#-----------------------------------------------------------------------------------------}
puts $OPSChannel {#  5. DEFINE NODAL MASSES FOR MODELING WATER}
puts $OPSChannel {#-----------------------------------------------------------------------------------------}
puts $OPSChannel {}
*if((mElemType(int)==3)||(mElemType(int)==4))
puts $OPSChannel {model BasicBuilder -ndm 2 -ndf 3}
puts $OPSChannel {}
*endif
*#
puts $OPSChannel {# define nodal masses }
*set Cond Nodal_mass_on_lines *nodes
*add Cond Nodal_mass_on_nodes *nodes
*loop nodes *OnlyInCond
*set var h20dpth(real) = operation(cond(3,real)-NodesCoord(2,real))
*set var h20mass(real) = operation(h20dpth(real)*cond(2,real))
*set var xMass(real) = operation(cond(4,real)*h20mass)
*set var yMass(real) = operation(cond(5,real)*h20mass)
*if((mElemType(int)==3)||(mElemType(int)==4))
*format "%8i %10.3f %10.3f"
puts $OPSChannel {mass *NodesNum *xMass *yMass       0.000}
*else
*format "%8i %10.3f %10.3f"
puts $OPSChannel {mass *NodesNum *xMass *yMass}
*endif
*end nodes
puts $OPSChannel {puts "Finished creating nodal masses..."}
puts $OPSChannel {#-----------------------------------------------------------------------------------------}
puts $OPSChannel {#  6. CREATE GRAVITY RECORDERS}
puts $OPSChannel {#-----------------------------------------------------------------------------------------}
puts $OPSChannel {}
puts $OPSChannel {# create list with soil node info
set nodeListS {}
set channel [open "nodeInfo.dat" r]
set ctr 0;
foreach line [split [read -nonewline $channel] \n] {
set ctr0 [expr $ctr+1];
set lineData($ctr) $line
set nodeNumber [lindex $lineData($ctr) 0]
lappend nodeListS $nodeNumber
}
close $channel

# create solid element list
set SoilElementList {}
set channel [open "elementInfo.dat" r]
set ctr 0;
foreach line [split [read -nonewline $channel] \n] {
set ctr0 [expr $ctr+1];
set lineData($ctr) $line
set elementNumber [lindex $lineData($ctr) 0]
lappend SoilElementList $elementNumber
}
close $channel

*if((mElemType(int)==1)||(mElemType(int)==2))
# record nodal displacement
eval "recorder Node -file Gdisplacement.out -time -node $nodeListS -dof 1 2 disp"
eval "recorder Node -file Gacceleration.out -time -node $nodeListS -dof 1 2 accel"
*#
*elseif((mElemType(int)==3)||(mElemType(int)==4))
# record nodal displacement, acceleration, and pore pressure
eval "recorder Node -file Gdisplacement.out -time -node $nodeListS -dof 1 2  disp"
eval "recorder Node -file Gacceleration.out -time -node $nodeListS -dof 1 2  accel"
eval "recorder Node -file GporePressure.out -time -node $nodeListS -dof 3    vel"
*endif
*#
# record elemental stress and strain
*if((mElemType(int)==1)||(mElemType(int)==3))
eval "recorder Element -file Gstress1.out   -time -ele $SoilElementList   material 1 stress"
eval "recorder Element -file Gstress2.out   -time -ele $SoilElementList   material 2 stress"
eval "recorder Element -file Gstress3.out   -time -ele $SoilElementList   material 3 stress"
eval "recorder Element -file Gstress4.out   -time -ele $SoilElementList   material 4 stress"
eval "recorder Element -file Gstrain1.out   -time -ele $SoilElementList   material 1 strain"
eval "recorder Element -file Gstrain2.out   -time -ele $SoilElementList   material 2 strain"
eval "recorder Element -file Gstrain3.out   -time -ele $SoilElementList   material 3 strain"
eval "recorder Element -file Gstrain4.out   -time -ele $SoilElementList   material 4 strain"
*#
*elseif((mElemType(int)==2)||(mElemType(int)==4))
eval "recorder Element -file Gstress.out -time -ele $SoilElementList stress 3"
eval "recorder Element -file Gstrain.out -time -ele $SoilElementList strain"
*endif
puts "Finished creating gravity recorders..."
}
puts $OPSChannel {}
puts $OPSChannel {#-----------------------------------------------------------------------------------------}
puts $OPSChannel {#  7. DEFINE ANALYSIS PARAMETERS}
puts $OPSChannel {#-----------------------------------------------------------------------------------------}
puts $OPSChannel {}
puts $OPSChannel {#---RAYLEIGH DAMPING PARAMETERS}
puts $OPSChannel {set pi      3.141592654}
puts $OPSChannel {# damping ratio}
puts $OPSChannel {set damp    0.02}
puts $OPSChannel {# lower frequency}
puts $OPSChannel {set omega1  [expr 2**$pi**0.2]}
puts $OPSChannel {# upper frequency}
puts $OPSChannel {set omega2  [expr 2**$pi**20]}
puts $OPSChannel {# damping coefficients}
puts $OPSChannel {set a0      [expr 2**$damp**$omega1**$omega2/($omega1 + $omega2)]}
puts $OPSChannel {set a1      [expr 2**$damp/($omega1 + $omega2)]}
puts $OPSChannel {puts "damping coefficients: a_0 = $a0;  a_1 = $a1"}
puts $OPSChannel {}
puts $OPSChannel {#---ANALYSIS PARAMETERS}
puts $OPSChannel {# Newmark parameters}
puts $OPSChannel {set gamma   [expr 5.0/6.0]}
puts $OPSChannel {set beta    [expr 4.0/9.0]}
puts $OPSChannel {}
puts $OPSChannel {#-----------------------------------------------------------------------------------------}
puts $OPSChannel {#  8. GRAVITY ANALYSIS}
puts $OPSChannel {#-----------------------------------------------------------------------------------------}
puts $OPSChannel {}
*if(matShift==1000)
puts $OPSChannel {InitialStateAnalysis on}
puts $OPSChannel {}
*endif
*#
puts $OPSChannel {# update materials to ensure elastic behavior}
*loop materials
puts $OPSChannel {updateMaterialStage -material *matnum() -stage 0}
*end materials
puts $OPSChannel {}
*if(matShift==1000)
*if(iniType==1)
*#
puts $OPSChannel {constraints Transformation}
puts $OPSChannel {test        NormDispIncr 1e-2 35 0}
puts $OPSChannel {algorithm   Newton}
puts $OPSChannel {numberer    RCM}
puts $OPSChannel {system      ProfileSPD}
puts $OPSChannel {integrator  LoadControl 1.0}
puts $OPSChannel {analysis    Static}
puts $OPSChannel {}
puts $OPSChannel {set startT  [clock seconds]}
puts $OPSChannel {analyze     5}
puts $OPSChannel {}
puts $OPSChannel {# update material bulk and shear moduli while remaining elastic}
*loop materials
puts $OPSChannel {updateMaterialStage -material *matnum() -stage 2}
*end materials
puts $OPSChannel {}
puts $OPSChannel {integrator LoadControl 0.2}
puts $OPSChannel {analyze     5}
puts $OPSChannel {puts "Finished with elastic gravity analysis..."}
puts $OPSChannel {}
puts $OPSChannel {InitialStateAnalysis off}
puts $OPSChannel {}
puts $OPSChannel {analyze     5}
puts $OPSChannel {}
puts $OPSChannel {# update materials to consider plastic behavior}
*loop materials
puts $OPSChannel {updateMaterialStage -material *matnum() -stage 1}
*end materials
puts $OPSChannel {}
puts $OPSChannel {# plastic gravity loading}
puts $OPSChannel {integrator LoadControl 0.2}
puts $OPSChannel {analyze     5}
puts $OPSChannel {puts "Finished with plastic gravity analysis..."}
*#
*elseif(iniType==2)
*#
puts $OPSChannel {constraints Transformation}
puts $OPSChannel {test        NormDispIncr 1e-2 35 0}
puts $OPSChannel {algorithm   Newton}
puts $OPSChannel {numberer    RCM}
puts $OPSChannel {system      ProfileSPD}
puts $OPSChannel {integrator  LoadControl 1.0}
puts $OPSChannel {analysis    Static}
puts $OPSChannel {}
puts $OPSChannel {set startT  [clock seconds]}
puts $OPSChannel {analyze 5}
puts $OPSChannel {puts "Finished with elastic gravity analysis..."}
puts $OPSChannel {}
puts $OPSChannel {# update materials to consider plastic behavior}
*loop materials
puts $OPSChannel {updateMaterialStage -material *matnum() -stage 1}
*end materials
puts $OPSChannel {}
puts $OPSChannel {analyze 4}
puts $OPSChannel {puts "Finished with plastic gravity analysis..."}
puts $OPSChannel {}
puts $OPSChannel {InitialStateAnalysis off}
puts $OPSChannel {}
puts $OPSChannel {remove sp *dNode 1}
puts $OPSChannel {remove sp *IniNode 1}
*endif
*#
*elseif((mElemType(int)==3)||(mElemType(int)==4))
*#
puts $OPSChannel {#constraints Transformation}
puts $OPSChannel {constraints Penalty 1e15 1e15}
puts $OPSChannel {test        NormDispIncr 1e-2 35 0}
puts $OPSChannel {algorithm   Newton}
puts $OPSChannel {numberer    RCM}
puts $OPSChannel {system      Mumps}
puts $OPSChannel {integrator  Newmark $gamma $beta}
puts $OPSChannel {analysis    Transient}
puts $OPSChannel {}
puts $OPSChannel {set startT  [clock seconds]}
puts $OPSChannel {analyze     10 5.0e2}
puts $OPSChannel {puts "Finished with elastic gravity analysis..."}
puts $OPSChannel {}
puts $OPSChannel {# update materials to consider plastic behavior}
*loop materials
puts $OPSChannel {updateMaterialStage -material *matnum() -stage 1}
*end materials
puts $OPSChannel {source firstCall.dat}
puts $OPSChannel {}
puts $OPSChannel {analyze 10 1.0}
puts $OPSChannel {puts "Finished with plastic gravity analysis..."}												 
*else
*#
puts $OPSChannel {constraints Transformation}
puts $OPSChannel {test        NormDispIncr 1e-2 35 0}
puts $OPSChannel {algorithm   Newton}
puts $OPSChannel {numberer    RCM}
puts $OPSChannel {system      ProfileSPD}
puts $OPSChannel {integrator  LoadControl 1.0}
puts $OPSChannel {analysis    Static}
puts $OPSChannel {}
puts $OPSChannel {set startT  [clock seconds]}
puts $OPSChannel {analyze     5}
puts $OPSChannel {puts "Finished with elastic gravity analysis..."}
puts $OPSChannel {}
puts $OPSChannel {# update materials to consider plastic behavior}
*loop materials
puts $OPSChannel {updateMaterialStage -material *matnum() -stage 1}
*end materials
puts $OPSChannel {}
puts $OPSChannel {source firstCall.dat}
puts $OPSChannel {}
puts $OPSChannel {# plastic gravity loading}
puts $OPSChannel {integrator LoadControl 0.2}
puts $OPSChannel {analyze     5}
puts $OPSChannel {puts "Finished with plastic gravity analysis..."}
*endif
puts $OPSChannel {}
*if((mElemType(int)==3)||(mElemType(int)==4))
puts $OPSChannel {#-----------------------------------------------------------------------------------------}
puts $OPSChannel {#  9. UPDATE ELEMENT PERMEABILITY VALUES FOR POST-GRAVITY ANALYSIS}
puts $OPSChannel {#-----------------------------------------------------------------------------------------}
puts $OPSChannel {}
*set elems(Quadrilateral)
*loop elems
puts $OPSChannel {setParameter -value $hPerm*ElemsMat -ele *ElemsNum hPerm}
puts $OPSChannel {setParameter -value $vPerm*ElemsMat -ele *ElemsNum vPerm}
*end elems
puts $OPSChannel {}
*endif
*#
*if((mElemType(int)==1)||(mElemType(int)==2))
puts $OPSChannel {#-----------------------------------------------------------------------------------------}
puts $OPSChannel {#  9. CREATE POST-GRAVITY RECORDERS}
puts $OPSChannel {#-----------------------------------------------------------------------------------------}
*elseif((mElemType(int)==3)||(mElemType(int)==4))
puts $OPSChannel {#-----------------------------------------------------------------------------------------}
puts $OPSChannel {#  10. CREATE POST-GRAVITY RECORDERS}
puts $OPSChannel {#-----------------------------------------------------------------------------------------}
*endif
puts $OPSChannel {}
puts $OPSChannel {# reset time and analysis}
puts $OPSChannel {setTime 0.0}
puts $OPSChannel {wipeAnalysis}
puts $OPSChannel {remove recorders}
puts $OPSChannel {}
puts $OPSChannel {}
puts $OPSChannel {
# define velocity time history file
set velocityFile motion1.vel
set accFile  motion1.acc
set timeFile motion1.time

#---GROUND MOTION PARAMETERS
# read number of lines in the velocity file
set channel [open $timeFile r]
set timeVec [split [read -nonewline $channel] \n]
set motionSteps [llength $timeVec]
set t1 [lindex $timeVec 0]
set t2 [lindex $timeVec 1]
set motionDT [expr $t2 - $t1]
close $channel

set duration [expr $motionSteps ** $motionDT]

# new dt to use for analysis
# set motionDT 0.0025
# set motionSteps [expr int($duration / $motionDT) + 1]

set AnalysisdT  0.001
set RecorderdT 0.01
set nSteps  [expr int(floor($duration/$AnalysisdT)+1)]
set dT      $AnalysisdT

puts "Number of motion steps: $motionSteps"
puts "Motion time step: $motionDT"
puts "Motion length: $duration"
}
puts $OPSChannel {
*if((mElemType(int)==1)||(mElemType(int)==2))
# record nodal displacement
eval "recorder Node -file displacement.out -time -dT $RecorderdT -node $nodeListS -dof 1 2 disp"
eval "recorder Node -file acceleration.out -time -dT $RecorderdT -node $nodeListS -dof 1 2 accel"
*#
*elseif((mElemType(int)==3)||(mElemType(int)==4))
# record nodal displacement, acceleration, and pore pressure
eval "recorder Node -file displacement.out -time -dT $RecorderdT -node $nodeListS -dof 1 2  disp"
eval "recorder Node -file acceleration.out -time -dT $RecorderdT -node $nodeListS -dof 1 2  accel"
eval "recorder Node -file porePressure.out -time -dT $RecorderdT -node $nodeListS -dof 3    vel"
*endif
*#
# record elemental stress and strain
*if((mElemType(int)==1)||(mElemType(int)==3))
eval "recorder Element -file stress1.out   -time -dT $RecorderdT -ele $SoilElementList   material 1 stress"
eval "recorder Element -file stress2.out   -time -dT $RecorderdT -ele $SoilElementList   material 2 stress"
eval "recorder Element -file stress3.out   -time -dT $RecorderdT -ele $SoilElementList   material 3 stress"
eval "recorder Element -file stress4.out   -time -dT $RecorderdT -ele $SoilElementList   material 4 stress"
eval "recorder Element -file strain1.out   -time -dT $RecorderdT -ele $SoilElementList   material 1 strain"
eval "recorder Element -file strain2.out   -time -dT $RecorderdT -ele $SoilElementList   material 2 strain"
eval "recorder Element -file strain3.out   -time -dT $RecorderdT -ele $SoilElementList   material 3 strain"
eval "recorder Element -file strain4.out   -time -dT $RecorderdT -ele $SoilElementList   material 4 strain"
*#
*elseif((mElemType(int)==2)||(mElemType(int)==4))
eval "recorder Element -file stress.out -time -dT $RecorderdT -ele $SoilElementList stress 3"
eval "recorder Element -file strain.out -time -dT $RecorderdT -ele $SoilElementList strain"
*endif
}
puts $OPSChannel {puts "Finished creating all recorders..."}
puts $OPSChannel {}
*if((mElemType(int)==1)||(mElemType(int)==2))
puts $OPSChannel {#-----------------------------------------------------------------------------------------}
puts $OPSChannel {#  10. DYNAMIC ANALYSIS}
puts $OPSChannel {#-----------------------------------------------------------------------------------------}
*elseif((mElemType(int)==3)||(mElemType(int)==4))
puts $OPSChannel {#-----------------------------------------------------------------------------------------}
puts $OPSChannel {#  11. DYNAMIC ANALYSIS}
puts $OPSChannel {#-----------------------------------------------------------------------------------------}
*endif
puts $OPSChannel {
set mSeries "Path -fileTime $timeFile -filePath $accFile -factor 9.81"

pattern UniformExcitation 10 1 -accel $mSeries
puts "Dynamic loading created..."

set gamma  0.5
set beta   0.25

constraints Penalty 1.e15 1.e15
# constraints Transformation
test        NormDispIncr 1.0e-2 35 0
algorithm   Newton
numberer    RCM
system      Mumps
integrator  Newmark $gamma $beta
rayleigh    $a0 $a1 0.0 0.0
analysis    Transient

# Set number and length of (pseudo)time steps
set numStep $nSteps

#set numStep 0

# Analyze and use substepping if needed
set remStep $numStep
set success 0
proc subStepAnalyze {dT subStep} {
        if {$subStep > 10} {
                return -10
        }
        for {set i 1} {$i < 3} {incr i} {
                puts "Try dT = $dT"
                set success [analyze 1 $dT]
                if {$success != 0} {
                        set success [subStepAnalyze [expr $dT/2.0] [expr $subStep+1]]
                        if {$success == -10} {
                                puts "Did not converge."
                                return success
                        }
                } else {
                        if {$i==1} {
                                puts "Substep $subStep : Left side converged with dT = $dT"
                        } else {
                                puts "Substep $subStep : Right side converged with dT = $dT"
                        }
                }
        }
        return success
}

puts "Start analysis"
set startT [clock seconds]

while {$success != -10} {
        set subStep 0
        set success [analyze $remStep  $dT]
        if {$success == 0} {
                puts "Analysis Finished"
                break
        } else {
                set curTime  [getTime]
                puts "Analysis failed at $curTime . Try substepping."
                set success  [subStepAnalyze [expr $dT/2.0] [incr subStep]]
        set curStep  [expr int($curTime/$dT + 1)]
        set remStep  [expr int($numStep-$curStep)]
                puts "Current step: $curStep , Remaining steps: $remStep"
        }
}
set endT [clock seconds]
puts "loading analysis execution time: [expr $endT-$startT] seconds."
wipe
}


*set Cond FirstCall_on_surfaces *elems
*loop elems *OnlyInCond
puts $firstCall {	
setParameter -value 0 -ele *ElemsNum FirstCall *ElemsMat
# setParameter -value 0.3 -ele *ElemsNum poissonRatio *ElemsMat}
*end elems

*set Cond PostShake_on_surfaces *elems
*loop elems *OnlyInCond
puts $postShake {	
setParameter -value 0 -ele *ElemsNum PostShake *ElemsMat}
*end elems